Index: tmp/org.txm.setups/nsis/Include/LangFile.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Include/LangFile.nsh	(revision 2955)
+++ tmp/org.txm.setups/nsis/Include/LangFile.nsh	(revision 2956)
@@ -2,27 +2,50 @@
 
 LangFile.nsh
 
-Header file to create langauge files that can be
+Header file to create language files that can be
 included with a single command.
 
-Copyright 2008-2015 Joost Verburg
+Copyright 2008-2020 Joost Verburg, Anders Kjersem
 
 * Either LANGFILE_INCLUDE or LANGFILE_INCLUDE_WITHDEFAULT
-  can be called from the script to include a language
-  file.
+  can be called from the script to include a language file.
 
   - LANGFILE_INCLUDE takes the language file name as parameter.
   - LANGFILE_INCLUDE_WITHDEFAULT takes as additional second
-    parameter the default language file to load missing strings
-    from.
+    parameter, the default language file to load missing strings from.
 
-* A language file start with:
-  !insertmacro LANGFILE_EXT "English"
-  using the same name as the standard NSIS language file.
-
 * Language strings in the language file have the format:
   ${LangFileString} LANGSTRING_NAME "Text"
 
+* There are two types of language header files:
+
+  - NSIS multi-lang support; these must start with the LANGFILE macro and 
+    provide strings for features like MUI and MultiUser. If you are adding 
+    support for a new language to NSIS you should make a copy of English.nsh 
+    and translate this .nsh along with the .nlf.
+  - Custom installer strings; these must start with the LANGFILE_EXT macro and 
+    contain translated versions of 
+    custom strings used in a particular installer.
+    This is useful if you want to put the translations for each language in 
+    their own separate file.
+
+* Example:
+
+  ; Setup.nsi
+  !include "MUI.nsh"
+  !insertmacro MUI_PAGE_INSTFILES
+  !insertmacro MUI_LANGUAGE "Danish"
+  !insertmacro LANGFILE_INCLUDE "DanishExtra.nsh"
+  !insertmacro MUI_LANGUAGE "Swedish"
+  !insertmacro LANGFILE_INCLUDE "SwedishExtra.nsh"
+  Section
+  MessageBox MB_OK "$(myCustomString)"
+  SectionEnd
+
+  ; SwedishExtra.nsh
+  !insertmacro LANGFILE_EXT Swedish
+  ${LangFileString} myCustomString "Bork bork"
+
 */
 
 !ifndef LANGFILE_INCLUDED
@@ -30,7 +53,7 @@
 
 !macro LANGFILE_INCLUDE FILENAME
 
-  ;Called from script: include a langauge file
+  ;Called from script: include a language file
 
   !ifdef LangFileString
     !undef LangFileString
@@ -43,16 +66,14 @@
   !undef LANGFILE_SETNAMES
 
   ;Create language strings
-
-  !undef LangFileString
-  !define LangFileString "!insertmacro LANGFILE_LANGSTRING"
+  !define /redef LangFileString "!insertmacro LANGFILE_LANGSTRING"
   !include "${FILENAME}"
 
 !macroend
 
 !macro LANGFILE_INCLUDE_WITHDEFAULT FILENAME FILENAME_DEFAULT
 
-  ;Called from script: include a langauge file
+  ;Called from script: include a language file
   ;Obtains missing strings from a default file
 
   !ifdef LangFileString
@@ -66,31 +87,65 @@
   !undef LANGFILE_SETNAMES
 
   ;Include default language for missing strings
+  !define LANGFILE_PRIV_INCLUDEISFALLBACK "${FILENAME_DEFAULT}"
   !include "${FILENAME_DEFAULT}"
-  
+  !undef LANGFILE_PRIV_INCLUDEISFALLBACK
+
   ;Create language strings
-  !undef LangFileString
-  !define LangFileString "!insertmacro LANGFILE_LANGSTRING"
+  !define /redef LangFileString "!insertmacro LANGFILE_LANGSTRING"
   !include "${FILENAME_DEFAULT}"
 
 !macroend
 
-!macro LANGFILE IDNAME NAME
+!macro LANGFILE NLFID ENGNAME NATIVENAME NATIVEASCIINAME
 
   ;Start of standard NSIS language file
 
+  ; NLFID: Must match the name of the .nlf file
+  ; ENGNAME: English name of language, "=" if it is the same as NLFID
+  ; NATIVENAME: Native name of language. (In Unicode)
+  ; NATIVEASCIINAME: Native name of language using only ASCII, "=" if it is the same as NATIVENAME
+
+  ; Example: LANGFILE "Swedish" = "Svenska" = (This is the same as LANGFILE "Swedish" "Swedish" "Svenska" "Svenska")
+  ; For more examples, see French.nsh, Greek.nsh and PortugueseBR.nsh
+
   !ifdef LANGFILE_SETNAMES
 
     !ifdef LANGFILE_IDNAME
       !undef LANGFILE_IDNAME
     !endif
 
-    !define LANGFILE_IDNAME "${IDNAME}"
+    !define LANGFILE_IDNAME "${NLFID}"
 
-    !ifndef "LANGFILE_${IDNAME}_NAME"
-      !define "LANGFILE_${IDNAME}_NAME" "${NAME}"
+    ; ModernUI or the .nsi can change LANGFILE_LANGDLL_FMT if desired
+    !ifndef LANGFILE_LANGDLL_FMT
+      !ifndef NSIS_UNICODE
+        !define LANGFILE_LANGDLL_FMT "%ENGNAME% / %NATIVEASCIINAME%"
+      !endif
+      !define /ifndef LANGFILE_LANGDLL_FMT "%NATIVENAME%"
     !endif
 
+    !ifndef "LANGFILE_${NLFID}_NAME"
+      !if "${ENGNAME}" == "="
+        !define /redef ENGNAME "${NLFID}"
+      !endif
+      !if "${NATIVEASCIINAME}" == "="
+        !define /redef NATIVEASCIINAME "${NATIVENAME}"
+      !endif
+
+      !define "LANGFILE_${NLFID}_ENGLISHNAME" "${ENGNAME}"
+      !ifdef NSIS_UNICODE
+        !define "LANGFILE_${NLFID}_NAME" "${NATIVENAME}"
+      !else
+        !define "LANGFILE_${NLFID}_NAME" "${NATIVEASCIINAME}"
+      !endif
+
+      !searchreplace LANGFILE_${NLFID}_LANGDLL "${LANGFILE_LANGDLL_FMT}" %NATIVEASCIINAME% "${NATIVEASCIINAME}"
+      !searchreplace LANGFILE_${NLFID}_LANGDLL "${LANGFILE_${NLFID}_LANGDLL}" %NATIVENAME% "${NATIVENAME}"
+      !searchreplace LANGFILE_${NLFID}_LANGDLL "${LANGFILE_${NLFID}_LANGDLL}" %ENGNAME% "${ENGNAME}"
+
+    !endif
+
   !endif
 
 !macroend
@@ -117,6 +172,9 @@
 
   !ifndef ${NAME}
     !define "${NAME}" "${VALUE}"
+    !ifdef LANGFILE_PRIV_INCLUDEISFALLBACK
+      !warning 'LangString "${NAME}" for language ${LANGFILE_IDNAME} is missing, using fallback from "${LANGFILE_PRIV_INCLUDEISFALLBACK}"'
+    !endif
   !endif
 
 !macroend
Index: tmp/org.txm.setups/nsis/Include/InstallOptions.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Include/InstallOptions.nsh	(revision 2955)
+++ tmp/org.txm.setups/nsis/Include/InstallOptions.nsh	(revision 2956)
@@ -125,16 +125,20 @@
 
   InitPluginsDir
   File "/oname=$PLUGINSDIR\${FILE}" "${FILE}"
+!ifdef NSIS_UNICODE
+  InstallOptions::make_unicode "$PLUGINSDIR\${FILE}"
+!endif
   !insertmacro INSTALLOPTIONS_WRITE "${FILE}" "Settings" "RTL" "$(^RTL)"
 
-  !verbose pop
-
 !macroend
 
 !macro INSTALLOPTIONS_EXTRACT_AS FILE FILENAME
 
   InitPluginsDir
   File "/oname=$PLUGINSDIR\${FILENAME}" "${FILE}"
+!ifdef NSIS_UNICODE
+  InstallOptions::make_unicode "$PLUGINSDIR\${FILENAME}"
+!endif
   !insertmacro INSTALLOPTIONS_WRITE "${FILENAME}" "Settings" "RTL" "$(^RTL)"
 
 !macroend
Index: tmp/org.txm.setups/nsis/Include/nsDialogs.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Include/nsDialogs.nsh	(revision 2955)
+++ tmp/org.txm.setups/nsis/Include/nsDialogs.nsh	(revision 2956)
@@ -6,43 +6,43 @@
 */
 
 !ifndef NSDIALOGS_INCLUDED
+!verbose push 2
 !define NSDIALOGS_INCLUDED
-!verbose push
 !verbose 3
 
 !include LogicLib.nsh
 !include WinMessages.nsh
 
-!define WS_EX_DLGMODALFRAME  0x00000001
-!define WS_EX_NOPARENTNOTIFY 0x00000004
-!define WS_EX_TOPMOST        0x00000008
-!define WS_EX_ACCEPTFILES    0x00000010
-!define WS_EX_TRANSPARENT    0x00000020
-!define WS_EX_MDICHILD       0x00000040
-!define WS_EX_TOOLWINDOW     0x00000080
-!define WS_EX_WINDOWEDGE     0x00000100
-!define WS_EX_CLIENTEDGE     0x00000200
-!define WS_EX_CONTEXTHELP    0x00000400
-!define WS_EX_RIGHT          0x00001000
-!define WS_EX_LEFT           0x00000000
-!define WS_EX_RTLREADING     0x00002000
-!define WS_EX_LTRREADING     0x00000000
-!define WS_EX_LEFTSCROLLBAR  0x00004000
-!define WS_EX_RIGHTSCROLLBAR 0x00000000
-!define WS_EX_CONTROLPARENT  0x00010000
-!define WS_EX_STATICEDGE     0x00020000
-!define WS_EX_APPWINDOW      0x00040000
+!define /ifndef WS_EX_DLGMODALFRAME  0x00000001
+!define /ifndef WS_EX_NOPARENTNOTIFY 0x00000004
+!define /ifndef WS_EX_TOPMOST        0x00000008
+!define /ifndef WS_EX_ACCEPTFILES    0x00000010
+!define /ifndef WS_EX_TRANSPARENT    0x00000020
+!define /ifndef WS_EX_MDICHILD       0x00000040
+!define /ifndef WS_EX_TOOLWINDOW     0x00000080
+!define /ifndef WS_EX_WINDOWEDGE     0x00000100
+!define /ifndef WS_EX_CLIENTEDGE     0x00000200
+!define /ifndef WS_EX_CONTEXTHELP    0x00000400
+!define /ifndef WS_EX_RIGHT          0x00001000
+!define /ifndef WS_EX_LEFT           0x00000000
+!define /ifndef WS_EX_RTLREADING     0x00002000
+!define /ifndef WS_EX_LTRREADING     0x00000000
+!define /ifndef WS_EX_LEFTSCROLLBAR  0x00004000
+!define /ifndef WS_EX_RIGHTSCROLLBAR 0x00000000
+!define /ifndef WS_EX_CONTROLPARENT  0x00010000
+!define /ifndef WS_EX_STATICEDGE     0x00020000
+!define /ifndef WS_EX_APPWINDOW      0x00040000
 
-!define WS_CHILD             0x40000000
-!define WS_VISIBLE           0x10000000
-!define WS_DISABLED          0x08000000
-!define WS_CLIPSIBLINGS      0x04000000
-!define WS_CLIPCHILDREN      0x02000000
-!define WS_MAXIMIZE          0x01000000
-!define WS_VSCROLL           0x00200000
-!define WS_HSCROLL           0x00100000
-!define WS_GROUP             0x00020000
-!define WS_TABSTOP           0x00010000
+!define /ifndef WS_CHILD             0x40000000
+!define /ifndef WS_VISIBLE           0x10000000
+!define /ifndef WS_DISABLED          0x08000000
+!define /ifndef WS_CLIPSIBLINGS      0x04000000
+!define /ifndef WS_CLIPCHILDREN      0x02000000
+!define /ifndef WS_MAXIMIZE          0x01000000
+!define /ifndef WS_VSCROLL           0x00200000
+!define /ifndef WS_HSCROLL           0x00100000
+!define /ifndef WS_GROUP             0x00020000
+!define /ifndef WS_TABSTOP           0x00010000
 
 !define ES_LEFT              0x00000000
 !define ES_CENTER            0x00000001
@@ -58,6 +58,7 @@
 !define ES_READONLY          0x00000800
 !define ES_WANTRETURN        0x00001000
 !define ES_NUMBER            0x00002000
+!define ES_SAVESEL           0x00008000
 
 !define SS_LEFT              0x00000000
 !define SS_CENTER            0x00000001
@@ -152,28 +153,98 @@
 !define LBS_NOSEL             0x4000
 !define LBS_COMBOBOX          0x8000
 
-!define LR_DEFAULTCOLOR     0x0000
-!define LR_MONOCHROME       0x0001
-!define LR_COLOR            0x0002
-!define LR_COPYRETURNORG    0x0004
-!define LR_COPYDELETEORG    0x0008
-!define LR_LOADFROMFILE     0x0010
-!define LR_LOADTRANSPARENT  0x0020
-!define LR_DEFAULTSIZE      0x0040
-!define LR_VGACOLOR         0x0080
-!define LR_LOADMAP3DCOLORS  0x1000
-!define LR_CREATEDIBSECTION 0x2000
-!define LR_COPYFROMRESOURCE 0x4000
-!define LR_SHARED           0x8000
+!define ACS_CENTER      0x0001
+!define ACS_TRANSPARENT 0x0002 ;  The parent of the animation control must not have the WS_CLIPCHILDREN style
+!define ACS_AUTOPLAY    0x0004
+!define ACS_TIMER       0x0008 ; < CC6
 
-!define IMAGE_BITMAP        0
-!define IMAGE_ICON          1
-!define IMAGE_CURSOR        2
-!define IMAGE_ENHMETAFILE   3
+!define TBS_AUTOTICKS        0x0001
+!define TBS_VERT             0x0002
+!define TBS_HORZ             0x0000
+!define TBS_TOP              0x0004
+!define TBS_BOTTOM           0x0000
+!define TBS_LEFT             0x0004
+!define TBS_RIGHT            0x0000
+!define TBS_BOTH             0x0008
+!define TBS_NOTICKS          0x0010
+!define TBS_ENABLESELRANGE   0x0020
+!define TBS_FIXEDLENGTH      0x0040
+!define TBS_NOTHUMB          0x0080
+!define TBS_TOOLTIPS         0x0100 ; IE3
+!define TBS_REVERSED         0x0200 ; IE5
+!define TBS_DOWNISLEFT       0x0400 ; _WIN32_IE >= 0x0501
+!define TBS_NOTIFYBEFOREMOVE 0x0800 ; IE6?
+!define TBS_TRANSPARENTBKGND 0x1000 ; Vista
 
-!define GWL_STYLE           -16
-!define GWL_EXSTYLE         -20
+!define UDS_WRAP        0x0001
+!define UDS_SETBUDDYINT 0x0002
+!define UDS_ALIGNRIGHT  0x0004
+!define UDS_ALIGNLEFT   0x0008
+!define UDS_AUTOBUDDY   0x0010
+!define UDS_ARROWKEYS   0x0020
+!define UDS_HORZ        0x0040
+!define UDS_NOTHOUSANDS 0x0080
+!define UDS_HOTTRACK    0x0100 ; 98+
 
+!define MCS_DAYSTATE        0x0001
+!define MCS_MULTISELECT     0x0002
+!define MCS_WEEKNUMBERS     0x0004
+!define MCS_NOTODAYCIRCLE   0x0008
+!define MCS_NOTODAY         0x0010 ; IE4+?
+!define MCS_NOTRAILINGDATES  0x0040 ; Vista+
+!define MCS_SHORTDAYSOFWEEK  0x0080 ; Vista+
+!define MCS_NOSELCHANGEONNAV 0x0100 ; Vista+
+
+!define DTS_UPDOWN          0x01
+!define DTS_SHOWNONE        0x02
+!define DTS_SHORTDATEFORMAT 0x00
+!define DTS_LONGDATEFORMAT  0x04
+!define DTS_SHORTDATECENTURYFORMAT 0x0C
+!define DTS_TIMEFORMAT      0x09
+!define DTS_APPCANPARSE     0x10
+!define DTS_RIGHTALIGN      0x20
+
+!define /ifndef LR_DEFAULTCOLOR     0x0000
+!define /ifndef LR_MONOCHROME       0x0001
+!define /ifndef LR_COLOR            0x0002
+!define /ifndef LR_COPYRETURNORG    0x0004
+!define /ifndef LR_COPYDELETEORG    0x0008
+!define /ifndef LR_LOADFROMFILE     0x0010
+!define /ifndef LR_LOADTRANSPARENT  0x0020
+!define /ifndef LR_DEFAULTSIZE      0x0040
+!define /ifndef LR_VGACOLOR         0x0080
+!define /ifndef LR_LOADMAP3DCOLORS  0x1000
+!define /ifndef LR_CREATEDIBSECTION 0x2000
+!define /ifndef LR_COPYFROMRESOURCE 0x4000
+!define /ifndef LR_SHARED           0x8000
+
+!define /ifndef IMAGE_BITMAP        0
+!define /ifndef IMAGE_ICON          1
+!define /ifndef IMAGE_CURSOR        2
+!define /ifndef IMAGE_ENHMETAFILE   3
+
+!define /ifndef GWL_STYLE           -16
+!define /ifndef GWL_EXSTYLE         -20
+
+#define /ifndef ICC_LISTVIEW_CLASSES 0x0001 ; SysListView32 and SysHeader32
+#define /ifndef ICC_TREEVIEW_CLASSES 0x0002 ; SysTabControl32 and tooltips_class32
+#define /ifndef ICC_BAR_CLASSES      0x0004 ; ToolbarWindow32, msctls_statusbar32, msctls_trackbar32 and tooltips_class32
+#define /ifndef ICC_TAB_CLASSES      0x0008 ; SysTabControl32 and tooltips_class32
+#define /ifndef ICC_UPDOWN_CLASS     0x0010 ; msctls_updown32
+#define /ifndef ICC_PROGRESS_CLASS   0x0020 ; msctls_progress32
+#define /ifndef ICC_HOTKEY_CLASS     0x0040 ; msctls_hotkey32
+#define /ifndef ICC_ANIMATE_CLASS    0x0080 ; SysAnimate32
+#define /ifndef ICC_WIN95_CLASSES    0x00FF
+!define /ifndef ICC_DATE_CLASSES     0x0100 ; CC4.70+ (NT4+/IE3.1+/Win95 OSR2) SysDateTimePick32, SysMonthCal32 and CC6.10+(Vista+) DropDown
+!define /ifndef ICC_USEREX_CLASSES   0x0200 ; CC4.??+ (NT4+/IE3.?+/Win95 OSR2) ComboBoxEx32
+!define /ifndef ICC_COOL_CLASSES     0x0400 ; CC4.70+ (NT4+/IE3.1+/Win95 OSR2) ReBarWindow32
+!define /ifndef ICC_INTERNET_CLASSES 0x0800 ; CC4.71+ (IE4+) SysIPAddress32
+!define /ifndef ICC_PAGESCROLLER_CLASS 0x1000 ; CC4.71+ (IE4+) SysPager
+!define /ifndef ICC_NATIVEFNTCTL_CLASS 0x2000 ; CC4.71+ (IE4+) NativeFontCtl
+!define /ifndef ICC_STANDARD_CLASSES 0x4000 ; WinXP+ Button, Static, Edit, ListBox, ComboBox, ComboLBox, ScrollBar and ReaderModeCtl
+!define /ifndef ICC_LINK_CLASS       0x8000 ; WinXP+ SysLink
+
+
 !define DEFAULT_STYLES ${WS_CHILD}|${WS_VISIBLE}|${WS_CLIPSIBLINGS}
 
 !define __NSD_HLine_CLASS STATIC
@@ -224,6 +295,10 @@
 !define __NSD_Text_STYLE ${DEFAULT_STYLES}|${WS_TABSTOP}|${ES_AUTOHSCROLL}
 !define __NSD_Text_EXSTYLE ${WS_EX_WINDOWEDGE}|${WS_EX_CLIENTEDGE}
 
+!define __NSD_MLText_CLASS EDIT
+!define __NSD_MLText_STYLE ${DEFAULT_STYLES}|${WS_TABSTOP}|${ES_AUTOHSCROLL}|${ES_AUTOVSCROLL}|${ES_MULTILINE}|${ES_WANTRETURN}|${WS_HSCROLL}|${WS_VSCROLL}
+!define __NSD_MLText_EXSTYLE ${WS_EX_WINDOWEDGE}|${WS_EX_CLIENTEDGE}
+
 !define __NSD_Password_CLASS EDIT
 !define __NSD_Password_STYLE ${DEFAULT_STYLES}|${WS_TABSTOP}|${ES_AUTOHSCROLL}|${ES_PASSWORD}
 !define __NSD_Password_EXSTYLE ${WS_EX_WINDOWEDGE}|${WS_EX_CLIENTEDGE}
@@ -240,6 +315,18 @@
 !define __NSD_DirRequest_STYLE ${DEFAULT_STYLES}|${WS_TABSTOP}|${ES_AUTOHSCROLL}
 !define __NSD_DirRequest_EXSTYLE ${WS_EX_WINDOWEDGE}|${WS_EX_CLIENTEDGE}
 
+!define __NSD_RichEdit_CLASS_10  "RICHEDIT"    ; 1.0 (Riched32.dll) Win95/NT4
+!define __NSD_RichEdit_CLASS_20A "RICHEDIT20A" ; 2.0 (Riched20.dll) Win98/NT4 (NSIS makes sure this is registered even on Windows 95)
+!define __NSD_RichEdit_CLASS_20W "RICHEDIT20W"
+!define __NSD_RichEdit_CLASS_41W "RICHEDIT50W" ; 4.1 (MsftEdit.DLL) WinXP.SP1
+!ifdef NSIS_UNICODE
+!define /ifndef __NSD_RichEdit_CLASS ${__NSD_RichEdit_CLASS_20W}
+!else
+!define /ifndef __NSD_RichEdit_CLASS ${__NSD_RichEdit_CLASS_20A}
+!endif
+!define __NSD_RichEdit_STYLE ${DEFAULT_STYLES}|${WS_TABSTOP}|${ES_AUTOHSCROLL}|${ES_AUTOVSCROLL}|${ES_MULTILINE}|${ES_WANTRETURN}|${ES_SAVESEL}|${WS_HSCROLL}|${WS_VSCROLL}
+!define __NSD_RichEdit_EXSTYLE ${WS_EX_WINDOWEDGE}|${WS_EX_CLIENTEDGE}
+
 !define __NSD_ComboBox_CLASS COMBOBOX
 !define __NSD_ComboBox_STYLE ${DEFAULT_STYLES}|${WS_TABSTOP}|${WS_VSCROLL}|${WS_CLIPCHILDREN}|${CBS_AUTOHSCROLL}|${CBS_HASSTRINGS}|${CBS_DROPDOWN}
 !define __NSD_ComboBox_EXSTYLE ${WS_EX_WINDOWEDGE}|${WS_EX_CLIENTEDGE}
@@ -252,16 +339,62 @@
 !define __NSD_ListBox_STYLE ${DEFAULT_STYLES}|${WS_TABSTOP}|${WS_VSCROLL}|${LBS_DISABLENOSCROLL}|${LBS_HASSTRINGS}|${LBS_NOINTEGRALHEIGHT}|${LBS_NOTIFY}
 !define __NSD_ListBox_EXSTYLE ${WS_EX_WINDOWEDGE}|${WS_EX_CLIENTEDGE}
 
+!define __NSD_SortedListBox_CLASS LISTBOX
+!define __NSD_SortedListBox_STYLE ${__NSD_ListBox_STYLE}|${LBS_SORT}
+!define __NSD_SortedListBox_EXSTYLE ${__NSD_ListBox_EXSTYLE}
+
 !define __NSD_ProgressBar_CLASS msctls_progress32
 !define __NSD_ProgressBar_STYLE ${DEFAULT_STYLES}
 !define __NSD_ProgressBar_EXSTYLE ${WS_EX_WINDOWEDGE}|${WS_EX_CLIENTEDGE}
 
+!define __NSD_Animation_CLASS SysAnimate32
+!define __NSD_Animation_STYLE ${DEFAULT_STYLES}|${ACS_TRANSPARENT}|${ACS_AUTOPLAY}
+!define __NSD_Animation_EXSTYLE 0
+
+!define __NSD_HTrackBar_CLASS msctls_trackbar32
+!define __NSD_HTrackBar_STYLE ${DEFAULT_STYLES}|${TBS_HORZ}|${TBS_AUTOTICKS}|${TBS_TOOLTIPS}
+!define __NSD_HTrackBar_EXSTYLE 0
+
+!define __NSD_VTrackBar_CLASS msctls_trackbar32
+!define __NSD_VTrackBar_STYLE ${DEFAULT_STYLES}|${TBS_VERT}|${TBS_AUTOTICKS}|${TBS_TOOLTIPS}
+!define __NSD_VTrackBar_EXSTYLE 0
+
+!define __NSD_UpDown_CLASS msctls_updown32
+!define __NSD_UpDown_STYLE ${DEFAULT_STYLES}|${UDS_SETBUDDYINT}|${UDS_ARROWKEYS}|${UDS_NOTHOUSANDS}|${UDS_ALIGNRIGHT}
+!define __NSD_UpDown_EXSTYLE 0
+
+!define __NSD_AutoUpDown_CLASS msctls_updown32
+!define __NSD_AutoUpDown_STYLE ${__NSD_UpDown_STYLE}|${UDS_AUTOBUDDY}
+!define __NSD_AutoUpDown_EXSTYLE ${__NSD_UpDown_EXSTYLE}
+
+!define __NSD_HotKey_CLASS msctls_hotkey32
+!define __NSD_HotKey_STYLE ${DEFAULT_STYLES}
+!define __NSD_HotKey_EXSTYLE ${WS_EX_WINDOWEDGE}|${WS_EX_CLIENTEDGE}
+
+!define __NSD_Calendar_CLASS SysMonthCal32
+!define __NSD_Calendar_STYLE ${DEFAULT_STYLES}|${WS_TABSTOP}
+!define __NSD_Calendar_EXSTYLE 0
+
+!define __NSD_DatePicker_CLASS SysDateTimePick32
+!define __NSD_DatePicker_STYLE ${DEFAULT_STYLES}|${WS_TABSTOP}
+!define __NSD_DatePicker_EXSTYLE ${WS_EX_WINDOWEDGE}|${WS_EX_CLIENTEDGE}
+
+!define __NSD_TimePicker_CLASS SysDateTimePick32
+!define __NSD_TimePicker_STYLE ${DEFAULT_STYLES}|${WS_TABSTOP}|${DTS_TIMEFORMAT}
+!define __NSD_TimePicker_EXSTYLE ${WS_EX_WINDOWEDGE}|${WS_EX_CLIENTEDGE}
+
+!define __NSD_IPAddress_CLASS SysIPAddress32 ; IE4+/CC4.71+
+!define __NSD_IPAddress_STYLE ${DEFAULT_STYLES}|${WS_TABSTOP}
+!define __NSD_IPAddress_EXSTYLE 0
+
+!define __NSD_NetAddress_CLASS msctls_netaddress ; Vista+
+!define __NSD_NetAddress_STYLE ${DEFAULT_STYLES}|${WS_TABSTOP}
+!define __NSD_NetAddress_EXSTYLE ${WS_EX_WINDOWEDGE}|${WS_EX_CLIENTEDGE}
+
+
 !macro __NSD_DefineControl NAME
-
 	!define NSD_Create${NAME} "nsDialogs::CreateControl ${__NSD_${Name}_CLASS} ${__NSD_${Name}_STYLE} ${__NSD_${Name}_EXSTYLE}"
-
 !macroend
-
 !insertmacro __NSD_DefineControl HLine
 !insertmacro __NSD_DefineControl VLine
 !insertmacro __NSD_DefineControl Label
@@ -274,17 +407,31 @@
 !insertmacro __NSD_DefineControl CheckBox
 !insertmacro __NSD_DefineControl RadioButton
 !insertmacro __NSD_DefineControl Text
+!insertmacro __NSD_DefineControl MLText
 !insertmacro __NSD_DefineControl Password
 !insertmacro __NSD_DefineControl Number
 !insertmacro __NSD_DefineControl FileRequest
 !insertmacro __NSD_DefineControl DirRequest
+!insertmacro __NSD_DefineControl RichEdit
 !insertmacro __NSD_DefineControl ComboBox
 !insertmacro __NSD_DefineControl DropList
 !insertmacro __NSD_DefineControl ListBox
+!insertmacro __NSD_DefineControl SortedListBox
 !insertmacro __NSD_DefineControl ProgressBar
+!insertmacro __NSD_DefineControl Animation
+!insertmacro __NSD_DefineControl HTrackBar
+!insertmacro __NSD_DefineControl VTrackBar
+!insertmacro __NSD_DefineControl UpDown
+!insertmacro __NSD_DefineControl AutoUpDown
+!insertmacro __NSD_DefineControl HotKey
+!insertmacro __NSD_DefineControl Calendar
+!insertmacro __NSD_DefineControl DatePicker
+!insertmacro __NSD_DefineControl TimePicker
+!insertmacro __NSD_DefineControl IPAddress
+!insertmacro __NSD_DefineControl NetAddress
 
+
 !macro __NSD_OnControlEvent EVENT HWND FUNCTION
-
 	Push $0
 	Push $1
 
